\ProvidesPackage{sleek}[2020/10/29 v1.01 Sleek Package]

%%%%%%%%%%%%%%%%
% Requirements %
%%%%%%%%%%%%%%%%

% Encoding

\RequirePackage[utf8]{inputenc}
\RequirePackage[T1]{fontenc}
\RequirePackage{eurosym}

% Style

\RequirePackage{geometry}
\RequirePackage{fancyhdr}
\RequirePackage[bottom]{footmisc}

\edef\restoreparindent{\parindent=\the\parindent\relax}
\RequirePackage[parfill]{parskip}

\RequirePackage{enumitem}
\RequirePackage{csquotes}
\RequirePackage{xcolor}

% Links

\RequirePackage[
    pdfusetitle,
    colorlinks=true,
    linktoc=page,
    allcolors=blue
]{hyperref}

% Mathematics

\RequirePackage{amsmath}
\RequirePackage{amssymb}
\RequirePackage{bm}
\RequirePackage{esint}

% Units

\RequirePackage{siunitx}

% Figures

\RequirePackage{float}
\RequirePackage[skip=1em]{caption}

% Arrays

\RequirePackage{array}
\RequirePackage{booktabs}
\RequirePackage{multirow}
\RequirePackage{multicol}

% Bibliography

\RequirePackage[
    backend=biber,
    style=numeric-comp,
    sorting=none,
    maxbibnames=99,
    backref=true
]{biblatex}

%%%%%%%%%%%%
% Settings %
%%%%%%%%%%%%

% Parindent

\DeclareOption{parindent}{
    \restoreparindent
}

% Style

\geometry{top=3.5cm,bottom=2.5cm,right=2.5cm,left=2.5cm}

\pagestyle{fancy}
\fancyhead[L]{}
\fancyhead[R]{\leftmark}
\fancyfoot[C]{\thepage}
\renewcommand{\headrulewidth}{0pt}

\DeclareOption{noheader}{
    \fancyhead[R]{}
    \newgeometry{margin=2.5cm}
}

% Arrays

\renewcommand{\arraystretch}{1.1}

% Bibliography

\DefineBibliographyStrings{english}{
    backrefpage = {page},
    backrefpages = {pages}
}

\DefineBibliographyStrings{french}{
    backrefpage = {page},
    backrefpages = {pages}
}

% Languages

\DeclareOption{french}{
    %% Lists
    \frenchbsetup{StandardLists=true}

    %% Units
    \sisetup{output-decimal-marker=,}

    %% Captions
    \addto\captionsfrench{\def\figurename{Figure}}
    \addto\captionsfrench{\def\tablename{Table}}
    \addto\captionsfrench{\def\proofname{Preuve}}

    %% Macros
    \def\cad{c.-à-d.}
    \def\Cad{C.-à-d.}
}

%%%%%%%%%%%%
% Commands %
%%%%%%%%%%%%


% Mathematics

\newcommand{\rbk}[1]{\left(#1\right)} % round brackets (parentheses)
\newcommand{\cbk}[1]{\left\{#1\right\}} % curly brackets {braces}
\newcommand{\sbk}[1]{\left[#1\right]} % square brackets [brackets]
\newcommand{\abs}[1]{\left|#1\right|} % absolute value |x|
\newcommand{\norm}[1]{\left\|#1\right\|} % norm ||x||

\newcommand{\fact}[1]{#1!} % factorial x!
\newcommand{\diff}{\mathrm{d}} % upright 'd' for differential
\DeclareMathOperator{\tr}{tr} % trace

% Figures

\newcommand{\noskipcaption}[1]{\caption{#1}\vspace{-1em}} % caption without additional vertical space

% Footnotes

\makeatletter
\def\blindfootnote{\gdef\@thefnmark{}\@footnotetext} % footnote without number
\makeatother

\ProcessOptions\relax

\endinput
